// Description:
//
// Copyright (C) 2001 Frank Becker
//
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation;  either version 2 of the License,  or (at your option) any  later
// version.
//
// This program is distributed in the hope that it will be useful,  but  WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details
//
#include <Trace.hpp>
#include <BaseSurface.hpp>

#include <SoftSurface.hpp>
#if 0
#include <GLSurface.hpp>
#endif

BaseSurface *BaseSurface::_surf = 0;

BaseSurface::BaseSurface( int w, int h):
  _width(w),
  _height(h)
{
    XTRACE();
}

BaseSurface::~BaseSurface()
{
    XTRACE();
}

void BaseSurface::createSurface( const string &/*type*/, int w, int h)
{
    XTRACE();
#if 0
    if( type == SURFACE_SDL_GL)
    {
	_surf = new GLSurface( w, h);
    }
    else
#endif
    {
	_surf = new SoftSurface( w, h);
    }

    LOG_INFO << "Created " << _surf->Type() << endl;
}

